Attribute VB_Name = "SubClasser"
Option Explicit

'  DoNotTransfer   '      ,
'                  '     ,  
'                  ' .     .
'  TransferBefore  '      
'  TransferAfter   '      

Public Enum TransferMessageConstants
  DoNotTransfer
  TransferBefore
  TransferAfter
End Enum

Private Const GWL_WNDPROC = -4

Private Declare Function SetWindowLong Lib "user32.dll" Alias "SetWindowLongA" ( _
   ByVal hWnd As Long, _
   ByVal nIndex As Long, _
   ByVal dwNewLong As Long) As Long

Public Declare Function CallWindowProc Lib "user32.dll" Alias "CallWindowProcA" ( _
   ByVal lpPrevWndFunc As Long, _
   ByVal hWnd As Long, _
   ByVal msg As Long, _
   ByVal wParam As Long, _
   ByVal lParam As Long) As Long

Private m_colMembers As New Collection

'=========================================
'   :
'=========================================
'hWnd             - hWnd ,    .    
'MessageProcessor - ,    ISubclass
'TransferType     - ,    .
'                       TransferMessageConstants

Public Function AddSubclassHook( _
  ByVal hWnd As Long, _
      ByVal MessageProcessor As ISubclass, _
          ByVal TransferType As TransferMessageConstants) As Boolean

  Dim objNewMember As SubClassItem

  If hWnd Then
    If MessageProcessor Is Nothing Then
      Err.Raise 5, App.Title, "Invalid callback interface"

    Else
      Set objNewMember = New SubClassItem

      With objNewMember
        Set .CallObject = MessageProcessor
        .hWnd = hWnd
        .TransferHow = TransferType

'         WndProc    null,    
'         ,   SetLastError  
        m_colMembers.Add objNewMember, CStr(hWnd)

        .PrevProc = SetWindowLong(hWnd, GWL_WNDPROC, AddressOf SubClasser.WindowProc)

        If .PrevProc = 0 Then
          m_colMembers.Remove CStr(hWnd)

          Err.Raise 5, App.Title, "Invalid hWnd"

        End If

      End With

      AddSubclassHook = True

    End If

  Else
    Err.Raise 5, App.Title, "Invalid hWnd"

  End If

End Function
'
'
'
'
Public Function RemoveSubclassHook(ByVal hWnd As Long) As Boolean
  Dim objHook As SubClassItem
  
  Set objHook = Item(hWnd)
  
  If Not objHook Is Nothing Then
    SetWindowLong objHook.hWnd, GWL_WNDPROC, objHook.PrevProc
    m_colMembers.Remove CStr(hWnd)
    
    Set objHook.CallObject = Nothing
    Set objHook = Nothing
    
  End If
  
  RemoveSubclassHook = True
  
End Function
'
'
'
'
Private Function WindowProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
  Dim objCurHook As SubClassItem
  
  Set objCurHook = m_colMembers(CStr(hWnd)) '   ;)
  
  Select Case objCurHook.TransferHow
    Case DoNotTransfer
      '   .  ,   .
      WindowProc = objCurHook.CallObject.Callback(hWnd, uMsg, wParam, lParam, objCurHook.PrevProc)
    
    Case TransferBefore
      '  .    ,  .
      WindowProc = CallWindowProc(objCurHook.PrevProc, hWnd, uMsg, wParam, lParam)
      
      If objCurHook.CallObject Is Nothing Then
        Set objCurHook = Nothing
        
      Else
        objCurHook.CallObject.Callback hWnd, uMsg, wParam, lParam, 0
        
      End If
      
    Case TransferAfter
      '  .    ,  ByRef,
      '      .
      objCurHook.CallObject.Callback hWnd, uMsg, wParam, lParam, 0
      
      WindowProc = CallWindowProc(objCurHook.PrevProc, hWnd, uMsg, wParam, lParam)
      
  End Select

End Function
'
'
'
'
Public Sub RemoveAll()
  Dim objHook As SubClassItem
  
  For Each objHook In m_colMembers
    RemoveSubclassHook objHook.hWnd
    
  Next
  
End Sub
'
'
'
'
Public Function AlreadyOurs(ByVal hWnd As Long) As Boolean
  ' ...        
  AlreadyOurs = Not Item(hWnd) Is Nothing
  
End Function
'
'
'
'
Private Function Item(ByVal hWnd As Long) As SubClassItem
  On Error Resume Next
  Set Item = m_colMembers(CStr(hWnd))
  
End Function
